;----ATMEL BASIC deffinition--------------
.device ATmega8
.include "atmeldef.inc" 

;----deffinition der PORT's---------------
.equ	sound	=7	;PortB
.equ	sync	=0	;Port B
.equ	pixel	=7	;Port D

.macro  char_out		;Zeichenausgabe
	ld	r0, Z+		;2
	out	PORTD, r0	;1
	rol	r0              ;1
	out	PORTD, r0	;1
	rol	r0              ;1
	out	PORTD, r0	;1
	rol	r0              ;1
	out	PORTD, r0	;1
	rol	r0              ;1
	out	PORTD, r0	;1
	rol	r0              ;1
	out	PORTD, r0	;1
.endmacro

.macro  loop			;Warteschleife r17 * 3
	ldi	r17, @0
lop1:	dec	r17
	brne	lop1		;2
.endmacro

         .cseg
         .org	0


start:

;--- initialiesiere PORTB Graybar und SYNC --
;DDxn	PORTxn	PUD	I/O 	Pull-up 	Comment
;0 	0 	X 	Input 	No 		Tri-state (Hi-Z)
;0 	1 	0 	Input 	Yes		Pxn will source current if external pulled low.
;0 	1 	1 	Input 	No 		Tri-state (Hi-Z)
;1 	0 	X 	Output 	No 		Output Low (Sink)
;1 	1 	X 	Output 	No 		Output High (Source)


;-------setze Stackpointer (045F)----------
          ldi    r17, 0x5F
          out    SPL, r17
          ldi    r17, 0x04
          out    SPH, r17
;------------------------------------------

;------setze Graybar PORTS & Sound ----------------
          ldi    r17, 0x81
          out    DDRB, r17
          ldi    r17, 0x00
          out    PORTB, r17
;------------------------------------------

;------setze tasten PORTS ----------------
          ldi    r17, 0x00
          out    DDRC, r17
          ldi    r17, 0xfC
          out    PORTC, r17
;------------------------------------------

	ldi	r17, 0x00	;1
	out	ADMUX, r17	;1
	ldi	r17, 0xE0	;1
	out	ADCSRA, r17	;1


;------setze VIDEO PORTS-------------------
	sbi	DDRD, pixel
	cbi	PORTD, pixel
;------------------------------------------



;Kopiere Text in RAM
;------------------------------------------
	ldi	ZH, HIGH(test *2)
	ldi	ZL, LOW(test *2)
	ldi	XH, 0x00
	ldi	XL, 0x60
cl_r:	lpm	r17, Z+
	st	X+, r17
	cpi	XH, 0x3
	brne	cl_r
;------------------------------------------


	ldi	r22, 0x00

	rjmp	video



test:
.db	"01234567890123456789012345678901234567890123456789"
.db	"DAS IST EINE ZEILE MIT GENAU 50 ZEICHEN! TOLLLL..."
.db	"WAS KANN MAN DENN NUN DAMIT MACHEN? KEINE AHNUNG, "
.db	"ABER ICH DENKE DAS ES BESTIMMT ZU IRGENDETWAS GUT "
.db	"IST. LEIDER KANN ICH ZUR ZEIT NUR IN GROSSBUCHSTA-"
.db	"BEN SCHREIBEN DA NOCH KEINER DIE KLEINEN ENTURFEN "
.db	"HAT. DIESE WERDEN HOFFENTLICH BALD NACHGEREICHT.  "
.db	"DER GESAMMTE TEXT BEFINDET SICH IM RAM DES ATMEGA8"
.db	"UND KOENNTE JEDERZEIT DURCH EINE RX LEITUNG GEAEN-"
.db	"DERT WERDEN. DIESES FEATURE BAUEN WIR AUCH NOCH   "
.db     "EIN. WEGEN ZU WENIG RAM KOENNEN NUR 50*12 ZEICHEN "
.db	"AUF DEM TV AUSGEGEBEN WERDEN.       BIS DANN...   "









;******************************************************************************************
; Takt = 6MHz  =  6 Takte fr 1s
; Takt = 8MHz  =  8 Takte fr 1s
; Takt = 16MHz = 16 Takte fr 1s
;
; Aufbau Zeile 
; ------------
; eine Bildzeile dauert 64 s dies entspricht 384 / 512 / 1024 Takte
; sichtbares Bild 52s (6MHz=312t 8MHz=416 16MHz=832)
; + vsync impulse 4s  (6MHz=24t  8MHz=32  16MHz=64 )
; + Blackscreen 8s    (6MHz=48t  8MHz=64t 16MHz=128)
; 
; Bildaufbau
; ----------
; Das Fernsehbild besteht aus 2 Halbbildern (interlace) wegen der Flackerunterdrckung
; 1 Halbbild hat 312 Zeilen
;
;
;******************************************************************************************





;----start Videosignalerzeugung------------------------------------
video:    
	rcall  vsync

	nop
	nop
	ldi	r18, 0x3D
	rcall  linecl

	nop
	ldi	YH, 0x00
	ldi	YL, 0x60
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	nop
	rcall  	ktextfeld

	nop
	nop
	ldi	r18, 0x3D
	rcall  linecl

	rjmp	video
;-------------------------------------------------------






;-------------------657 takte----------------------------------------
; +3 vom rcall
; +4 vom return
; 50 *13 takte =650

pixzeile:

	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out

	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out

	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out

	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out

	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out
	char_out

	ret
;--------------------------------------------------------------------



;#####( Horizontale Synchronimpuls 12s = 187 takte)#####################
; +3 vom rcall
; +4 vom return
; +180 vom programm
hsync:	cbi	PORTD, pixel	;2	1,7s Black
	loop	0x08		;24
	cbi	PORTB, sync	;2	4,7s sync	
	loop	0x18		;72
	sbi	PORTB, sync	;2	5,6s Black
	loop	0x1A		;78
	ret			;4
;#######################################################################








;########## V-Sync ################

vsync:
;+12 vom rcall letzter hsync
;837 Takte Hsync -> Hsync 
;837 - 12 - 3 - 6 - 512 =


	cbi	PORTD, pixel	;2
	nop			;1
	com	r22		;1
vsync2:
	cpi	r22, 0xff	;1
	breq	v_even		;1-2

v_odd:	
	nop			;1

	ldi	r17, 0xCC	;818
vs_2:	nop
	dec	r17
	brne	vs_2
	nop
	nop


	rcall	trabant		;7 1/2 Zeilen +3
	ldi	r17, 0xaa	;63	;304	
	rcall	wait_xx
	nop
	nop
	rcall	hsync		;187
	ret			;4

v_even:
	ldi	r17, 0x63	;63
	rcall	wait_xx
	nop
	nop
	rcall	trabant
	rcall	hsync

	nop
	nop
	nop

	nop
	nop
	nop
	nop

	nop
	nop
	nop

	ldi	r18, 1
	rjmp	linecl

	ret

trabant:
;2,25s		= 36 takte
;29,75s	= 476 takte

;4,68 s	= 75 takte
;27,32s	= 437 takte


;............ VORTRABANT 2 1/2 zeilen.........
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474

;............ HauptTRABANT 2 1/2 zeilen.......
	cbi	PORTB, sync	;2
	rcall	w_435		;435
	sbi	PORTB, sync	;2
	rcall	w_73		;73
	cbi	PORTB, sync	;2
	rcall	w_435		;435
	sbi	PORTB, sync	;2
	rcall	w_73		;73
	cbi	PORTB, sync	;2
	rcall	w_435		;435
	sbi	PORTB, sync	;2
	rcall	w_73		;73
	cbi	PORTB, sync	;2
	rcall	w_435		;435
	sbi	PORTB, sync	;2
	rcall	w_73		;73
	cbi	PORTB, sync	;2
	rcall	w_435		;435
	sbi	PORTB, sync	;2
	rcall	w_73		;73


;............ NachTRABANT 2 1/2 zeilen......
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	rcall	w_474		;474
	cbi	PORTB, sync	;2
	rcall	w_34		;34
	sbi	PORTB, sync	;2
	nop
	rjmp	w_474		;474


w_34:
	ldi	r17, 0x8	;1
	nop			;1
	rjmp	wait_xx		;2
w_73:
	ldi	r17, 0x15
	nop
	rjmp	wait_xx		;2
w_474:
	ldi	r17, 0x9B
	rjmp	wait_xx
w_435:
	ldi	r17,0x8E
	rjmp	wait_xx
wait_xx:
	dec	r17
	brne	wait_xx
	ret			;4
;#####################################


















;##########( leere Zeilen )##################################
; + 13 takte vom Aufruf
; + 7 bein return vom hsync

linecl:	
	cbi    PORTD, pixel	;2

ll3:	ldi    r17, 0xcd	;820 takte
ll1:	dec    r17
	nop
	brne   ll1

	nop
	nop
	rcall  hsync		;75

	dec    r18		;1
	breq   ll4		;1-2

	ldi	r17, 0x03	;9
ll5:	dec	r17
	brne	ll5
	nop			;1
	nop			;1
	rjmp   ll3		;2

ll4:	ret
;##################################################################






;##########( TEXTFELD klein)##################################
; + 13 takte vom Aufruf
; + 7 bein return vom hsync
;---------------------------
;takte zwischen HSYNC = 837
;--------------------------
ktextfeld:	

;...................824 takte..........................
	ldi    XH, 0x02     ;1
	ldi    XL, 0xB8     ;1
	ldi    r19, 0x06    ;1

;----bereite Video zeile vor------316 Takte insg----------------
;YL = Pointer im ASCII Text

ktx_z0:	ldi    r17, 0x08	;
	rcall	ktx_z1		; (r17*95)+7 takte = 767

	loop	0x12

	rcall	hsync		;
	dec	r19		;1
	breq	ktx_e1		;1-2

	loop	0x04		;12
	rjmp	ktx_z0		;2

ktx_e1:
	ldi    r17, 0x02	;
	rcall	ktx_z1		; (r17*95)+7 takte = 197
	loop	0xD4		;636
	nop			;1
	rcall	hsync		;
	nop
	nop
	nop

	ldi    ZH, 0x02    ;1
	ldi    ZL, 0xB8    ;1
	ldi    XL, 0x08    ;1
ktnexxx:
	loop	0x1D		;87 t
	rcall	pixzeile	;657
	loop	0x1D		;87 t

	rcall	hsync		;187

	dec	XL		;1
	breq	ktnexxx2	;1-2
	nop
	nop
	rjmp	ktnexxx       ;2
ktnexxx2:
	ret	


ktx_z1:
	ld	ZL, Y+		;2------------------
	clr	ZH		;1
	subi	ZL, 0x20	;1
	lsl	ZL		;1
	lsl	ZL		;1	10 takte
	rol	ZH		;1
	lsl	ZL		;1
	rol	ZH		;1
	subi	ZH, 0xE4	;1 ZH = ZH + 0x1C---

	ldi	r18, 0x08	;1----------
ktx_z2:	lpm	r0, Z+		;3
	st	X, r0		;2
	adiw	XL, 50		;2     80 takte
	dec	r18		;1
	brne	ktx_z2		;2----------

	subi	XL, 0x8f	;1----------
	sbci	XH, 1		;1	5 takte
	dec	r17		;1
	brne	ktx_z1		;2------------------------------------
	ret

;##################################################################





.include "zeichen.inc"
         .exit